﻿using Infragistics.Controls.Grids;
using Infragistics.Samples.Framework;
using Infragistics.Samples.Shared.Models;
using Infragistics.Samples.Shared.Models.Common;
using System;
using System.Data;

namespace IGGrid.Samples.Data
{
    public partial class BindingDataTable : SampleContainer
    {
        public BindingDataTable()
        {
            InitializeComponent();        
        }

        /// <summary>
        /// Context.
        /// </summary>
        IGGrid.Samples.Data.DataProvider ViewModelContext
        { get { return DataContext as IGGrid.Samples.Data.DataProvider; } }


        private void OnDataObjectRequested(object sender, DataObjectCreationEventArgs e)
        {
            e.NewObject = DataProvider.ProcessDataObjectCreation(e.ObjectType);
        }

        private void M_Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            DataTable OriginalTable = ViewModelContext.GetDataTable();
            DataTable Copied = OriginalTable.Copy();

            OriginalTable.Clear();

            OriginalTable.Merge(Copied);

            System.Diagnostics.Debug.WriteLine("Rebuilt table. " + DataGrid.ToString());

        }
    }

    public class DataProvider : ObservableModel
    {
        private static DataTable _dataTable;
        public DataView DataViewOrders { get; set; }

        public DataTable GetDataTable() { return _dataTable; }

        public DataProvider()
        {
            _dataTable = NWindDataSource.GetTable(NWindTable.Customers);

            DataSet AllData = _dataTable.DataSet;

            AllData.Tables["Order Details"].Rows.Clear();
            AllData.Tables["Orders"].Rows.Clear();

            DataViewOrders = _dataTable.DefaultView;
        }

        public static DataRowView ProcessDataObjectCreation(Type objectType)
        {
            DataRowView result = null;
            if (_dataTable != null && objectType == typeof(DataRowView))
            {
                result = new DataView(_dataTable).AddNew();
            }

            return result;
        }
    }
}
